#include	<stdio.h>
#include        <stddef.h>
#include        <ctype.h>
#include        <stdlib.h>
#include        <math.h>
#include        <malloc.h>
#include        <errno.h>

#define sphere_dim   10      /** the number of dimensions of the sphere  ***/
#define per_processor_tries  1500000

#define NUM_PROC   1        /* SP2 number of processors. */

void srand48();
double drand48();
double pow();
double sqrt();

/*-----------------------------*/
double compute_mean(int n, int *monte_carlo_array)
{
  int i;
  double temp_mean = 0.0;

  for (i = 1; i <= n; i++)
    {
      temp_mean += ((double) monte_carlo_array[i]);
    }
  temp_mean /= ((double) n);
  return ((double) temp_mean);
}

/*-----------------------------*/
double compute_std(int n, int *monte_carlo_array, int mean)
{
  int i; 
  double temp_stdev = 0.0;

  for (i = 1; i <= n; i++)
    {
      temp_stdev += pow((double) monte_carlo_array[i] - mean, 2.0);
    }
  temp_stdev /= ((double) n);
  return((double) sqrt(temp_stdev));
}

/*-----------------------------*/
/*-----------------------------*/
main()
{
  int i, j;
  int *sphere_darts;      /* Based on MC probability, it stores (0,1) 
			     depending on whether dart thrown 
			     lands inside the circle or outside it ... */
  double volume;
  double pi;
  double mean;
  double stand_dev;
  double temp_stdev;
  double sphere_volume[NUM_PROC];      /* volume computed for all procs. */
  double stand_dev_array[NUM_PROC];    /* std computed for all procs. */
  double temp_sphere_radius = 0.0;

  srand48 ((double) 999999);
  sphere_darts = 
    (int *) malloc((per_processor_tries + 1) * sizeof(int));

/*** Step [1]: Compute a single point. ***/
  for(i=1; i <= per_processor_tries; i++)
    {
      temp_sphere_radius = 0.0;

      for(j=1; j <= sphere_dim; j++)
	{
	  temp_sphere_radius += pow(drand48(), 2.0);
	}
      if(temp_sphere_radius <= 1.0)
	{
	  sphere_darts[i] = 1;
	}
      else
	{
	  sphere_darts[i] = 0;
	}
    }

/*** Step [2]: Compute the mean. ***/
  mean = 
    (double) compute_mean(per_processor_tries, sphere_darts);

/*** Step [3]: Compute the sphere's volume. ***/
  volume = 
    (double) mean * pow(2.0, sphere_dim);

/*** Step [4]: Compute the standard deviation. ***/
  stand_dev = 
    (double) compute_std(per_processor_tries, sphere_darts, mean);

  printf("======================Output======================\n");
  printf("Volume of sphere of dim %d  is  %25.16e \n",sphere_dim, volume);
  printf("Standard dev. is %25.16e \n", stand_dev);
  printf("Total number of points is %d \n", 4*per_processor_tries);
  if(sphere_dim == 2)
    printf("In dimension 2, Volume of the Sphere = Pi = %25.16e \n", volume);
  printf("==================================================\n");
}

