#include <mpi.h>
#include <stdio.h>
#include <time.h>

main (argc, argv)
int argc; char *argv[];
{
  int rank, size;
  int send[100], recv[100];
  int msg_len=6;
  int i;
  int source=0, dest=1;
  int tag=0;
  time_t start, stop;

  MPI_Status status;

  /* Initialize MPI */
  MPI_Init(&argc,&argv);

    /* Get rank of this process and process group size */
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  printf("Hello from process %d of %d. \n", rank, size);
  
  start = time(NULL);    /* start the timer ... */
  /* Set up two arrays to act as message send/recv buffers. */
  for (i=0; i<msg_len; i++)
    {
      send[i]=i;
      recv[i]=0;
    }
  if (rank == source)
    {
      /* Source process send a message. */
      MPI_Send(send,msg_len,MPI_INT,dest,tag,MPI_COMM_WORLD);
      printf("Process %d sent:", rank);
      for (i=0; i<msg_len; i++)
	printf("%d", send[i]);
      printf("\n");
    }

  if (rank == dest)
    {
      /* Destination process receives a message. */
      MPI_Recv(recv,msg_len,MPI_INT,source,tag,MPI_COMM_WORLD,&status);
      printf("Process %d got :", rank);
      for (i=0; i<msg_len; i++)
	printf(" %d", recv[i]);
      printf(" from process %d. \n", status.MPI_SOURCE);
    }
  stop = time(NULL);             /* ... stop the timer ... */

  /* Wrap up MPI operations. */
  MPI_Finalize();
  printf("Process %d is finished. \n", rank);
  printf("... Total time = %4.2f seconds ... \n", difftime(stop, start));
}

