/* --------------------------------------------------------
 * Sample MPI program showing a circular shift to the right
 *
 * 11/20/94 Xianneng Shen
 * --------------------------------------------------------
 */

#include <stdio.h>
#include "mpi.h"
main(int argc, char **argv)
     {
     int size, rank, right, left, tag,
         inbuf, outbuf;
     MPI_Status  status;
     MPI_Request   request;
     inbuf = 0;
/* start MPI calls */
     MPI_Init(&argc, &argv);
/* find process rank  */
     MPI_Comm_rank(MPI_COMM_WORLD, &rank);
/* find the total # of processes in the MPI application  */
     MPI_Comm_size(MPI_COMM_WORLD, &size);

/* compute source and destination for messages */
     if (rank == size-1) right = 0;
     else right = rank + 1;
     if (rank == 0) left = size - 1;
     else left = rank - 1;
/* shift operation is carried out by sendreceive call  */
     outbuf = rank;
     tag = 1;
     MPI_Sendrecv(&outbuf, 1, MPI_INT, right, tag, &inbuf, 1, MPI_INT, left,
        tag, MPI_COMM_WORLD, &status);

     printf ("rank = %d, message received = %d\n", rank, inbuf);
     return (0);
     }
