      program mpi_vect_mat_mult
      include 'mpif.h'
      integer ndims,xmax,ymax,nnodes
      logical reorder
      parameter(ndims=2,num_neigh=4,reorder=.true.)
      parameter(xmax=1000,ymax=1000)
      integer comm,comm_cart,dims(ndims),neigh_def(ndims),ierr
      integer own_position(ndims),rank_source,rank_dest
      logical periods(ndims)
      integer status(MPI_STATUS_SIZE)
      double precision,allocatable,dimension(:,:) :: A,B,OA
      double precision,allocatable,dimension(:)   :: X,sX,sXO
      double precision m
      data dims /ndims * 0/
      integer  myid,nitems,nlines
      double precision time_begin,time_end 

      comm=MPI_COMM_WORLD
      call MPI_init(ierr)
      call MPI_COMM_RANK(comm,myid,ierr)
      call MPI_COMM_SIZE(comm,nnodes,ierr)
     
      nlines = xmax/nnodes
      allocate(OA(xmax,ymax+1))
      allocate(A(nlines,ymax))
      allocate(B(nlines,ymax))
      allocate(X(nlines))
      allocate(sXO(xmax)) 
      nitems = nlines*(ymax+1)
       
!initialize A matrix,which includes coefficient matrix and right-hand side
!at its ymax+1'th colum

     
      if (myid == nnodes -1) then
        call random_number(OA)
        OA = aint(30.0*OA+1)
        call random_number(sXO)
        sXO = aint(30.0*sXO)+1
        OA(:,ymax+1) = sXO
        do np = 0,nnodes-2
           call MPI_SEND(OA(np*nlines+1:(np+1)*nlines,:),nitems,&
             MPI_DOUBLE_PRECISION,np,0,comm,ierr)
        enddo
        A = OA(myid*nlines+1:(myid+1)*nlines,1:ymax)
        X = OA(myid*nlines+1:(myid+1)*nlines,ymax+1)

     else
        call MPI_RECV(B,nitems,MPI_DOUBLE_PRECISION,nnodes-1,0,comm,&
           status,ierr)
        A = B(:,1:ymax)
        X = B(:,ymax+1)
     endif
!start timer
    
     time_begin =  MPI_Wtime()
     call MPI_ALLGATHER(X,nlines,MPI_DOUBLE_PRECISION, &
              sXO,nlines,MPI_DOUBLE_PRECISION,comm,ierr)

     do i=1,nlines
       X(i) = sum(A(i,:)*sXO)
     enddo

     call MPI_GATHER(X,nlines,MPI_DOUBLE_PRECISION, &
      sXO,nlines,MPI_DOUBLE_PRECISION,0,comm,ierr)

!stop timer
    time_end =  MPI_Wtime()

    if (myid == 0) then
        print *,'Elapsed time for multiplying vector and matrix '
        print * ,'with dimension of'
        print *,'coefficient matrix',xmax,'by ',ymax,'is'
        print *,time_end-time_begin,' seconds'
    endif

    call MPI_FINALIZE(ierr)

      end
